﻿-- Author      : Nogarder
-- Create Date : 2013/4/27 15:19:13
NPA_Options.RegisterPageFunc("Core",function()
	--localization
	local Localization=NPA_Options.Localization.PagesMainCore
	local Tooltips=Localization.Tooltips
	--
	local parent=NPA_Options.MainFrame
	--main page
	local main=NPA_Options.Template.CreateFrameWithBar(NPA_Options.MainFrame,nil,410,590,nil,nil,nil,nil,NPA_Options.MainFrame)
	main:Hide()
	--
	local page=main.Frame
	--
	local ModuleList={}
	local CollectorList={}
	--
	--save
	local savebutton=NPA_Options.Template.CreateSpecialButton(page,133,15,"Save")
	savebutton:SetPoint("TOPLEFT",page,"TOPLEFT",5,-5)
	--reset
	local resetbutton=NPA_Options.Template.CreateSpecialButton(page,133,15,"Reset")
	resetbutton:SetPoint("TOPRIGHT",page,"TOPRIGHT",-5,-5)
	--cancel
	local cancelbutton=NPA_Options.Template.CreateSpecialButton(page,133,15,"Cancel")
	cancelbutton:SetPoint("LEFT",savebutton,"RIGHT",5,0)
	cancelbutton:SetPoint("RIGHT",resetbutton,"LEFT",-5,0)
	--
	local nameplatemodulelist=NPA_Options.Template.CreateCheckBoxList(page,170,360)
	nameplatemodulelist.Scroll:SetPoint("TOPLEFT",savebutton,"BOTTOMLEFT",0,-25)
	NPA_Options.Template.SetCheckBoxList(nameplatemodulelist)
	--
	local modulelistlabel=page:CreateFontString()
	modulelistlabel:SetFont(GameFontNormal:GetFont())
	modulelistlabel:SetText(Localization["NamePlateModule"])
	modulelistlabel:SetPoint("BOTTOM",nameplatemodulelist.Scroll,"TOP",0,5)
	--
	local datacollectorlist=NPA_Options.Template.CreateCheckBoxList(page,170,360)
	datacollectorlist.Scroll:SetPoint("TOPRIGHT",resetbutton,"BOTTOMRIGHT",-20,-25)
	NPA_Options.Template.SetCheckBoxList(datacollectorlist)
	--
	local datacollectorlabel=page:CreateFontString()
	datacollectorlabel:SetFont(GameFontNormal:GetFont())
	datacollectorlabel:SetText(Localization["DataCollector"])
	datacollectorlabel:SetPoint("BOTTOM",datacollectorlist.Scroll,"TOP",0,5)
	--
	nameplatemodulelist.OnValueUpdateFunc=function(name,checked)
		ModuleList[name]=checked
	end
	--
	datacollectorlist.OnValueUpdateFunc=function(name,checked)
		CollectorList[name]=checked
	end
	--ScrollFrameRender checkbox
	local scrollframerendercheckbox=NPA_Options.Template.CreateCheckBox(page,400,20,Localization["ScrollFrameRender"])
	NPA_Options.Template.SetTooltips(Tooltips["ScrollFrameRender"],scrollframerendercheckbox)
	scrollframerendercheckbox:SetPoint("TOPLEFT",nameplatemodulelist.Scroll,"BOTTOMLEFT",0,-10)
	--combie pet cooldown checkbox
	local combiepetcooldowncheckbox=NPA_Options.Template.CreateCheckBox(page,400,20,Localization["CombiePetCoolDown"])
	NPA_Options.Template.SetTooltips(Tooltips["CombiePetCoolDown"],combiepetcooldowncheckbox)
	combiepetcooldowncheckbox:SetPoint("TOPLEFT",scrollframerendercheckbox,"BOTTOMLEFT",0,-10)
	--instant as one second cast
	local instantasonesecondcastcheckbox=NPA_Options.Template.CreateCheckBox(page,400,20,Localization["InstantAsOneSecondCast"])
	NPA_Options.Template.SetTooltips(Tooltips["InstantAsOneSecondCast"],instantasonesecondcastcheckbox)
	instantasonesecondcastcheckbox:SetPoint("TOPLEFT",combiepetcooldowncheckbox,"BOTTOMLEFT",0,-10)
	--enable aura cache
	local enableauracachecheckbox=NPA_Options.Template.CreateCheckBox(page,400,20,Localization["EnableAuraCache"])
	NPA_Options.Template.SetTooltips(Tooltips["EnableAuraCache"],enableauracachecheckbox)
	enableauracachecheckbox:SetPoint("TOPLEFT",instantasonesecondcastcheckbox,"BOTTOMLEFT",0,-10)
	--enable advanced type
	local advancedtypecheckbox=NPA_Options.Template.CreateCheckBox(page,400,20,Localization["AdvancdedType"])
	NPA_Options.Template.SetTooltips(Tooltips["AdvancdedType"],advancedtypecheckbox)
	advancedtypecheckbox:SetPoint("TOPLEFT",enableauracachecheckbox,"BOTTOMLEFT",0,-10)
	--enable power match
	local powermatchcheckbox=NPA_Options.Template.CreateCheckBox(page,400,20,Localization["PowerMatch"])
	NPA_Options.Template.SetTooltips(Tooltips["PowerMatch"],powermatchcheckbox)
	powermatchcheckbox:SetPoint("TOPLEFT",advancedtypecheckbox,"BOTTOMLEFT",0,-10)
	--powermatchcheckbox:Hide()
	--
	local Load=function(default)
		local entry
		if(default)then
			entry=NPA.SettingManager.GetDefault("Core")
		else
			entry=NPA_Setting.Core
		end
		ModuleList=CopyTable(entry.NamePlateModules)
		CollectorList=CopyTable(entry.DataCollectors)
		NPA_Options.Template.UpdateCheckBoxList(nameplatemodulelist,ModuleList,Localization)
		NPA_Options.Template.UpdateCheckBoxList(datacollectorlist,CollectorList,Localization)
		NPA_Options.Template.SetCheckBox(scrollframerendercheckbox,entry.UsingScrollFrameRender)
		NPA_Options.Template.SetCheckBox(combiepetcooldowncheckbox,entry.CombiePetCoolDown)
		NPA_Options.Template.SetCheckBox(instantasonesecondcastcheckbox,entry.InstantAsOneSecondCast)
		NPA_Options.Template.SetCheckBox(enableauracachecheckbox,entry.EnableAuraCache)
		NPA_Options.Template.SetCheckBox(advancedtypecheckbox,entry.AdvancedType)
		NPA_Options.Template.SetCheckBox(powermatchcheckbox,entry.PowerMatch)
	end
	--
	local Save=function()
		NPA_Setting.Core.NamePlateModules=CopyTable(ModuleList)
		NPA_Setting.Core.DataCollectors=CopyTable(CollectorList)
		NPA_Setting.Core.UsingScrollFrameRender=scrollframerendercheckbox.Checked
		NPA_Setting.Core.CombiePetCoolDown=combiepetcooldowncheckbox.Checked
		NPA_Setting.Core.InstantAsOneSecondCast=instantasonesecondcastcheckbox.Checked
		NPA_Setting.Core.EnableAuraCache=enableauracachecheckbox.Checked
		NPA_Setting.Core.AdvancedType=advancedtypecheckbox.Checked
		NPA_Setting.Core.PowerMatch=powermatchcheckbox.Checked
		--fire event
		NPA.EventHandler.FireEvent(6,"ProfileManager_ProfileLoaded")
		Load()
	end
	--
	savebutton:HookScript("OnMouseUp",Save)
	resetbutton:HookScript("OnMouseUp",function()
		Load(true)
	end)
	--
	main.OnSetFunc=function()
		Load()
	end
	--
	NPA_Options.RegisterPage("Core",main)
end)
